#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <histoscope.h>
/*
 *	HsExample.c - program to generate random n-tuple and histogram data
 */
#define TRUE 1
main()
{
    int n_variables = 8;
    float values[8];
    int i, j, k, ntuple_id, hs1_id, hs2_id, indic_id;
    static char *names[8] = {      "X",      "Y",  "index",    "sqrt(X)",
    			     "sqrt(Y)", "log(X)", "log(Y)", "sin(index)"  };

    hs_initialize("HsExample.c");
    hs_histoscope(TRUE);
    ntuple_id = hs_create_ntuple(101, "Example Ntuple", "HS", n_variables,
    		names);
    hs1_id    = hs_create_1d_hist(102, "Example 1d Hist", "HS", "Y", "total",
		100, 3400., 5400.);
    hs2_id    = hs_create_2d_hist(103, "2d Hist Example", "HS","X", "Y", 
		"total", 100, 100, 3400., 5400., 3400., 5400.);
    indic_id  = hs_create_indicator(104, "Example Indicator", "HS", 0., 10000.);

    for (i = 1; i <= 10000; ++i) {
    
    	/* Random data computation - This could be any code you wish */
    	for (j = 0; j < 2; ++j) {
    	    values[j] = 0;
    	    for (k = 0; k < 1000; k++)
    	    	values[j] += fmod((float)random(), 10.);
    	}
    	values[2] = i;
    	values[3] = sqrt(values[0]);
    	values[4] = sqrt(values[1]);
    	values[5] = log(values[0]);
    	values[6] = log(values[1]);
    	values[7] = sin(values[2]);

    	hs_fill_ntuple(ntuple_id, values);
    	hs_fill_1d_hist(hs1_id, values[1], 1.);
    	hs_fill_2d_hist(hs2_id, values[0], values[1], 1.);
    	hs_set_indicator(indic_id, (float) i);
    	hs_update();

    	/*  Print one period per n-tuple fill, to get  */
    	/*   visual feedback of program operation      */
    	printf(".");
    	fflush(stdout); 
    }

    hs_save_file("HsExample.hs");
    hs_complete();
}

	
